import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = /*@__PURE__*/LRParser.deserialize({
  version: 14,
  states: "%pOVQPOOOhQPO'#CbOoQPO'#C^O!QQPO'#CiO!VQQO'#CmOOQO'#C^'#C^QOQPOOOOQO,58|,58|O!_QPO,58|OVQPO,59PO!gQPO,59TO!lQPO,59XO!tQQO,59XOVQPO'#CnO!yQPO1G.hOOQO1G.h1G.hO#RQPO1G.kO#ZQPO1G.oO#`QPO1G.sO#eQPO1G.sO#jQPO1G.sOOQO,59Y,59YOOQO-E6l-E6lOOQO7+$S7+$SO#rQPO7+$VOOQO7+$V7+$VO#zQPO7+$ZOOQO7+$_7+$_O$PQPO7+$_O$UQPO7+$_OOQO<<Gq<<GqO$ZQPO<<GuOOQO<<Gy<<GyO$`QPO<<GyOOQOAN=aAN=aOOQOAN=eAN=e",
  stateData: "$e~OeOS~ORTOTPOVQO[RO`SO~OSVO~PVOYXOcQXSQXfQXWQX~OVYO~Oi[OjZO~OS_Of]O~OgaO~O^bOkcO~OjdO~OSgOf]O~OWiOf]O~OhjO~O_kO~O^lO~O^lOkmO~OWnOf]O~O^oO~O_pO~O^qO~OZrO~O_sO~O",
  goto: "!QcPPdPPPpPPpPPPpPPPpvQUOQWPQ`XRe]XTOPX]Q^WSf^hRh`",
  nodeNames: "⚠ Program FormatIrElement String ] [ FormatIrList Identifier ) FormatIrCallExpression ( } { FormatIrIdInfo Number > < FormatIrIntern",
  maxTerm: 27,
  nodeProps: [
    ["openedBy", 4,"[",11,"{",15,"<"],
    ["closedBy", 5,"]",12,"}",16,">"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*V~RiXY!pYZ!p]^!ppq!prs#Rst#sxy#xyz#}z{$S|}$X!Q![$^![!]$f!^!_$k!`!a$p!c!}$u!}#O%T#P#Q%Y#R#S$u#T#]$u#]#^%_#^#f$u#f#g(q#g#o$u#o#p){#q#r*Q~!uSe~XY!pYZ!p]^!ppq!p~#UUOY#RZr#Rrs#hs#O#R#O#P#m#P~#R~#mOR~~#pPO~#R~#xOh~~#}OY~~$SOW~~$XOk~~$^Of~~$cP^~!Q![$^~$kOg~~$pO`~~$uO_~P$zRVP!c!}$u#R#S$u#T#o$u~%YOT~~%_OS~R%dTVP!c!}$u#R#S$u#T#b$u#b#c%s#c#o$uR%xTVP!c!}$u#R#S$u#T#h$u#h#i&X#i#o$uR&^TVP!c!}$u#R#S$u#T#X$u#X#Y&m#Y#o$uR&rTVP!c!}$u#R#S$u#T#f$u#f#g'R#g#o$uR'WTVP!c!}$u#R#S$u#T#b$u#b#c'g#c#o$uR'lTVP!c!}$u#R#S$u#T#X$u#X#Y'{#Y#o$uR(QTVP!c!}$u#R#S$u#T#W$u#W#X(a#X#o$uR(hRjQVP!c!}$u#R#S$u#T#o$uR(vTVP!c!}$u#R#S$u#T#X$u#X#Y)V#Y#o$uR)[TVP!c!}$u#R#S$u#T#Y$u#Y#Z)k#Z#o$uR)rRiQVP!c!}$u#R#S$u#T#o$u~*QO[~~*VOZ~",
  tokenizers: [0, 1],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const romeAstLanguage = /*@__PURE__*/LRLanguage.define({
    parser: /*@__PURE__*/parser.configure({
        props: [
            /*@__PURE__*/indentNodeProp.add({}),
            /*@__PURE__*/foldNodeProp.add({
                FormatIrList: foldInside,
                FormatIrCallExpression(tree) {
                    return {
                        from: tree.getChild('(').from + 1,
                        to: tree.getChild(')').to - 1
                    };
                }
            }),
            /*@__PURE__*/styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                "( )": tags.paren,
                "{ }": tags.bracket,
                "[ ]": tags.squareBracket,
                Number: tags.number,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
// const snippets: readonly Completion[] = [
//   snip("let ${binds} in ${expression}", {
//     label: "let",
//     detail: "Let ... in statement",
//     type: "keyword",
//   }),
//   snip("with ${expression}; ${expression}", {
//     label: "with",
//     detail: "With statement",
//     type: "keyword",
//   }),
// ];
function romeAst() {
    return new LanguageSupport(romeAstLanguage);
}

export { parser, romeAst, romeAstLanguage };
